diff -Nrc2 fontutils-0.5/lib/ChangeLog fontutils-0.6/lib/ChangeLog
*** fontutils-0.5/lib/ChangeLog	Thu Sep  3 09:31:06 1992
--- fontutils-0.6/lib/ChangeLog	Tue Oct 27 13:02:51 1992
***************
*** 1,2 ****
--- 1,45 ----
+ Tue Oct 27 12:56:15 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* Version 0.6.
+ 
+ Sun Oct 25 06:26:42 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* getopt.c: New version.
+ 
+ Thu Oct 22 17:58:12 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* make-suffix.c: Doc fix.
+ 
+ Tue Oct 20 11:57:57 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* filename.c (find_{gf,pk,tfm}_filename): Just concatenate the
+ 	suffix onto the main font name, don't replace a suffix.
+ 
+ Mon Oct  5 10:07:59 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* report.c (report_file): New variable.
+ 
+ Sun Oct  4 09:13:24 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* bb-list.c: New file, from bb-outline.c.
+         * GNUmakefile (c_only): Add it.
+         * bb-outline.c: Change calls and decls for new improved names.
+ 
+ Sat Oct  3 16:58:38 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* bb-outline.c: Doc fix.
+ 
+ Tue Sep 22 12:46:49 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+         * malloc.c (realloc): abort if we can't malloc enough memory to do
+           the realloc.
+ 
+         * bitmap.c (bb_ensure_bounds): new routine.
+         (extract_subbitmap): call it.
+ 
+ Mon Sep 21 12:00:35 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+         * malloc.c: define NO_NEW_HANDLER.
+ 
  Thu Sep  3 09:31:06 1992  Karl Berry  (karl@hayley)
  
diff -Nrc2 fontutils-0.5/lib/GNUmakefile fontutils-0.6/lib/GNUmakefile
*** fontutils-0.5/lib/GNUmakefile	Fri Jun 26 16:54:36 1992
--- fontutils-0.6/lib/GNUmakefile	Sun Oct  4 09:25:11 1992
***************
*** 25,31 ****
  # The headers are in the `include' directory, so don't use `c_and_h' for
  # anything.
! c_only = $(malloc) atou basename bb-outline bitmap bounding-box charcode\
! charspec cmdline concat concat3 concat4 concat5 dir-p dlsym edge	\
! encoding extend-fname float-ok fmod file-input file-output file-p	\
  filename find-suffix fix-num font getopt getopt1 hexify integer-ok	\
  libfile line list logreport make-prefix make-suffix math now numtoa	\
--- 25,31 ----
  # The headers are in the `include' directory, so don't use `c_and_h' for
  # anything.
! c_only = $(malloc) atou basename bb-list bb-outline bitmap bounding-box	\
! charcode charspec cmdline concat concat3 concat4 concat5 dir-p dlsym	\
! edge encoding extend-fname float-ok fmod file-input file-output file-p	\
  filename find-suffix fix-num font getopt getopt1 hexify integer-ok	\
  libfile line list logreport make-prefix make-suffix math now numtoa	\
diff -Nrc2 fontutils-0.5/lib/M.depend fontutils-0.6/lib/M.depend
*** fontutils-0.5/lib/M.depend	Wed Sep  2 17:20:08 1992
--- fontutils-0.6/lib/M.depend	Sun Oct 25 14:15:27 1992
***************
*** 8,16 ****
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h 
  bb-outline.o : bb-outline.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/bb-outline.h .././include/bitmap.h .././include/bounding-box.h \
!   .././include/edge.h 
  bitmap.o : bitmap.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 8,20 ----
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h 
+ bb-list.o : bb-list.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
+   .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
+   .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
+   .././include/types.h .././include/bb-list.h .././include/bounding-box.h 
  bb-outline.o : bb-outline.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/bb-outline.h .././include/bb-list.h .././include/bounding-box.h \
!   .././include/bitmap.h .././include/edge.h 
  bitmap.o : bitmap.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
diff -Nrc2 fontutils-0.5/lib/bb-list.c fontutils-0.6/lib/bb-list.c
*** fontutils-0.5/lib/bb-list.c
--- fontutils-0.6/lib/bb-list.c	Sun Oct  4 09:34:43 1992
***************
*** 0 ****
--- 1,76 ----
+ /* bb-list.c: operations on bounding box lists.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #include "config.h"
+ 
+ #include "bb-list.h"
+ 
+ 
+ /* This routine returns an initialized empty list.  */
+ 
+ bb_list_type
+ bb_list_init ()
+ {
+   bb_list_type bb_list;
+   
+   BB_LIST_LENGTH (bb_list) = 0;
+   BB_LIST_DATA (bb_list) = NULL;
+   
+   return bb_list;
+ }
+ 
+ /* Append BB to BB_LIST.  */
+ 
+ void
+ bb_list_append (bb_list_type *bb_list, bounding_box_type bb)
+ {
+   BB_LIST_LENGTH (*bb_list)++;
+   XRETALLOC (BB_LIST_DATA (*bb_list), BB_LIST_LENGTH (*bb_list),
+              bounding_box_type);
+ 
+   BB_LIST_ELT (*bb_list, BB_LIST_LENGTH (*bb_list) - 1) = bb;
+ }
+ 
+ /* Append the elements in the list B2 onto the end of B1.  */
+ 
+ void
+ bb_list_splice (bb_list_type *b1, bb_list_type b2)
+ {
+   unsigned new_length;
+   unsigned this_bb;
+ 
+   if (BB_LIST_LENGTH (b2) == 0)
+     return;
+     
+   assert (b1 != NULL);
+   
+   new_length = BB_LIST_LENGTH (*b1) + BB_LIST_LENGTH (b2);
+   XRETALLOC (BB_LIST_DATA (*b1), new_length, bounding_box_type);
+   
+   for (this_bb = 0; this_bb < BB_LIST_LENGTH (b2); this_bb++)
+     BB_LIST_ELT (*b1, BB_LIST_LENGTH (*b1)++) = BB_LIST_ELT (b2, this_bb);
+ }
+ 
+ /* Free the memory in a list.  */
+ 
+ void
+ bb_list_free (bb_list_type *bb_list)
+ {
+   if (BB_LIST_DATA (*bb_list) != NULL)
+     safe_free ((address *) &BB_LIST_DATA (*bb_list));
+ }
diff -Nrc2 fontutils-0.5/lib/bb-outline.c fontutils-0.6/lib/bb-outline.c
*** fontutils-0.5/lib/bb-outline.c	Sun Jun 21 14:42:02 1992
--- fontutils-0.6/lib/bb-outline.c	Sun Oct  4 09:34:43 1992
***************
*** 20,31 ****
  
  #include "bb-outline.h"
- #include "bitmap.h"
- #include "bounding-box.h"
  #include "edge.h"
  
  
! static bounding_box_type find_one_bb (bitmap_type, edge_type,
!                                       unsigned, unsigned, bitmap_type *);
! static void append_bb (bounding_box_list_type *, bounding_box_type);
  
  /* A character is made up of a list of one or more outlines.  Here, we
--- 20,28 ----
  
  #include "bb-outline.h"
  #include "edge.h"
  
  
! static bounding_box_type find_one_bb
!   (bitmap_type, edge_type, unsigned, unsigned, bitmap_type *);
  
  /* A character is made up of a list of one or more outlines.  Here, we
***************
*** 35,43 ****
     the starting place for one outline.  We get the bounding boxes of the
     outlines, and put them in a list to return.  We don't look at pixels
!    that are at or after the column LEFT_MARK and before RIGHT_MARK.  If
     FIND_INNER is false, we return only outside outlines; otherwise, we
     return both inside and outside.  */
  
! bounding_box_list_type
  find_outline_bbs (bitmap_type b, boolean find_inner,
                    int left_mark, int right_mark)
--- 32,40 ----
     the starting place for one outline.  We get the bounding boxes of the
     outlines, and put them in a list to return.  We don't look at pixels
!    that are at or after the column LEFT_MARK or before RIGHT_MARK.  If
     FIND_INNER is false, we return only outside outlines; otherwise, we
     return both inside and outside.  */
  
! bb_list_type
  find_outline_bbs (bitmap_type b, boolean find_inner,
                    int left_mark, int right_mark)
***************
*** 44,48 ****
  {
    unsigned row, col;
!   bounding_box_list_type bb_list = init_bounding_box_list ();
    bitmap_type marked = new_bitmap (BITMAP_DIMENSIONS (b));
  
--- 41,45 ----
  {
    unsigned row, col;
!   bb_list_type bb_list = bb_list_init ();
    bitmap_type marked = new_bitmap (BITMAP_DIMENSIONS (b));
  
***************
*** 70,74 ****
  	      /* If edge != START_EDGE, it's on an inner bounding box.  */
  	      if (find_inner || edge == START_EDGE)
!                 append_bb (&bb_list, bb);
  	    }
          }
--- 67,78 ----
  	      /* If edge != START_EDGE, it's on an inner bounding box.  */
  	      if (find_inner || edge == START_EDGE)
!                 {
!                   /* The numbers in BB as it comes in refer to pixels;
!                      we have to change the maximum row so that it refers
!                      to the edge beyond the last pixel.  */
!                   MAX_COL (bb)++;
! 
!                   bb_list_append (&bb_list, bb);
!                 }
  	    }
          }
***************
*** 77,82 ****
    return bb_list;
  }
! 
! 
  /* Here we find one of a character's outlines.  We're passed the
     position (ORIGINAL_ROW and ORIGINAL_COL) of a starting pixel and one
--- 81,85 ----
    return bb_list;
  }
! 
  /* Here we find one of a character's outlines.  We're passed the
     position (ORIGINAL_ROW and ORIGINAL_COL) of a starting pixel and one
***************
*** 107,189 ****
  
    return bb;
- }
- 
- /* Make all bounding boxes be OFFSET to the right.  */
- 
- void
- offset_bounding_box_list (bounding_box_list_type *bb_list, int offset)
- {
-   unsigned this_bb;
-   
-   for (this_bb = 0; this_bb < BB_LIST_LENGTH (*bb_list); this_bb++)
-     {
-       bounding_box_type *bb = &BB_LIST_ELT (*bb_list, this_bb);
-       MIN_COL (*bb) += offset;
-       MAX_COL (*bb) += offset;
-     }
- }
- 
- 
- /* Append a bounding box to the list.  This is called when we have
-    completed an entire pixel outline.  The numbers in BB as it comes in
-    refer to pixels; we have to change the maximum row so that it refers
-    to the edge beyond the last pixel.  */
- 
- static void
- append_bb (bounding_box_list_type *bb_list, bounding_box_type bb)
- {
-   BB_LIST_LENGTH (*bb_list)++;
-   BB_LIST_DATA (*bb_list)
-     = xrealloc (BB_LIST_DATA (*bb_list),
-                  BB_LIST_LENGTH (*bb_list) * sizeof (bounding_box_type));
-   MAX_COL (bb)++;
-   BB_LIST_ELT (*bb_list, BB_LIST_LENGTH (*bb_list) - 1) = bb;
- }
- 
- 
- /* This routine returns an initialized empty list.  */
- 
- bounding_box_list_type
- init_bounding_box_list ()
- {
-   bounding_box_list_type bb_list;
-   
-   BB_LIST_LENGTH (bb_list) = 0;
-   BB_LIST_DATA (bb_list) = NULL;
-   
-   return bb_list;
- }
- 
- 
- /* Put the elements in the list B2 onto the end of B1.  B2 is not
-    changed.  */
- 
- void
- append_bounding_box_list (bounding_box_list_type *b1,
-                           bounding_box_list_type b2)
- {
-   unsigned new_length;
-   unsigned this_bb;
- 
-   assert (b1 != NULL);
-   
-   if (BB_LIST_LENGTH (b2) == 0)
-     return;
-     
-   new_length = BB_LIST_LENGTH (*b1) + BB_LIST_LENGTH (b2);
-   BB_LIST_DATA (*b1)
-     = xrealloc (BB_LIST_DATA (*b1), new_length * sizeof (bounding_box_type));
-   
-   for (this_bb = 0; this_bb < BB_LIST_LENGTH (b2); this_bb++)
-     BB_LIST_ELT (*b1, BB_LIST_LENGTH (*b1)++) = BB_LIST_ELT (b2, this_bb);
- }
- 
- 
- /* Here is a routine that frees the memory in a bounding box list.  */
- 
- void
- free_bounding_box_list (bounding_box_list_type *bb_list)
- {
-   if (BB_LIST_DATA (*bb_list) != NULL)
-     safe_free ((address *) &BB_LIST_DATA (*bb_list));
  }
--- 110,112 ----
diff -Nrc2 fontutils-0.5/lib/bitmap.c fontutils-0.6/lib/bitmap.c
*** fontutils-0.5/lib/bitmap.c	Sun Jun 21 14:42:02 1992
--- fontutils-0.6/lib/bitmap.c	Tue Sep 22 13:19:17 1992
***************
*** 22,26 ****
  #include "bounding-box.h"
  
! 
  
  /* Make sure the bitmap is entirely white to begin with.  */
--- 22,26 ----
  #include "bounding-box.h"
  
! static void bb_ensure_bounds (bounding_box_type *, bitmap_type, string);
  
  /* Make sure the bitmap is entirely white to begin with.  */
***************
*** 72,78 ****
  
  /* Return the part of the bitmap SOURCE enclosed by the bounding box BB.
!    BB is interpreted in the bitmap's coordinates; for example, if
!    MIN_ROW (BB) == 10, the subimage will start in the tenth row from the
!    top of SOURCE.  */
  
  bitmap_type
--- 72,78 ----
  
  /* Return the part of the bitmap SOURCE enclosed by the bounding box BB.
!    BB is interpreted in bitmap coordinates, with y increasing downwards;
!    for example, if MIN_ROW (BB) == 10, the subimage will start in the
!    tenth row from the top of SOURCE.  */
  
  bitmap_type
***************
*** 80,98 ****
  {
    unsigned this_row;
!   bitmap_type answer = new_bitmap (bb_to_dimensions (bb));
    BITMAP_BITS (source) += MIN_ROW (bb) * BITMAP_WIDTH (source) + MIN_COL (bb);
    
    for (this_row = MIN_ROW (bb); this_row <= MAX_ROW (bb); this_row++)
      {
!       one_byte *answer_row = BITMAP_ROW (answer, this_row - MIN_ROW (bb));
  
!       memcpy (answer_row, BITMAP_BITS (source), BITMAP_WIDTH (answer));
        BITMAP_BITS (source) += BITMAP_WIDTH (source);
      }
  
!   return answer;
  }
  
  
  
  /* The bounding boxes that we make in this routine are unlike the
--- 80,135 ----
  {
    unsigned this_row;
!   bitmap_type sub = new_bitmap (bb_to_dimensions (bb));
!   
!   /* Move to the bit at which we want to start copying.  */
    BITMAP_BITS (source) += MIN_ROW (bb) * BITMAP_WIDTH (source) + MIN_COL (bb);
    
+   bb_ensure_bounds (&bb, source, "extract_subbitmap");
+ 
    for (this_row = MIN_ROW (bb); this_row <= MAX_ROW (bb); this_row++)
      {
!       one_byte *target = BITMAP_ROW (sub, this_row - MIN_ROW (bb));
  
!       memcpy (target, BITMAP_BITS (source), BITMAP_WIDTH (sub));
        BITMAP_BITS (source) += BITMAP_WIDTH (source);
      }
  
!   return sub;
  }
  
  
+ /* If any of the elements of BB (taken to be in bitmap coordinates) are
+    outside the bounds of the bitmap SOURCE, give a warning (using NAME)
+    and update them.  */
+ 
+ static void
+ bb_ensure_bounds (bounding_box_type *bb, bitmap_type source, string name)
+ {
+   if (MIN_COL (*bb) < 0)
+     {
+       WARNING2 ("%s: min col=%d outside source image", name, MIN_COL (*bb));
+       MIN_COL (*bb) = 0;
+     }
+ 
+   if (MIN_ROW (*bb) < 0)
+     {
+       WARNING2 ("%s: min row=%d outside source image", name, MIN_ROW (*bb));
+       MIN_COL (*bb) = 0;
+     }
+ 
+   /* See comments at `get_character_bitmap' in gf_input.c for why the
+      width and height are treated asymetrically.  */
+   if (MAX_COL (*bb) > BITMAP_WIDTH (source))
+     {
+       WARNING2 ("%s: max col=%d outside source image", name, MAX_COL (*bb));
+       MAX_COL (*bb) = BITMAP_WIDTH (source) - 1;
+     }
+ 
+   if (MAX_ROW (*bb) >= BITMAP_HEIGHT (source))
+     {
+       WARNING2 ("%s: max row=%d outside source image", name, MAX_ROW (*bb));
+       MAX_COL (*bb) = BITMAP_HEIGHT (source) - 1;
+     }
+ }
  
  /* The bounding boxes that we make in this routine are unlike the
***************
*** 194,199 ****
    return vector;
  }
- 
- 
  
  /* Print a part of the bitmap in human-readable form.  */
--- 231,234 ----
diff -Nrc2 fontutils-0.5/lib/filename.c fontutils-0.6/lib/filename.c
*** fontutils-0.5/lib/filename.c	Fri Apr 10 16:51:11 1992
--- fontutils-0.6/lib/filename.c	Tue Oct 20 12:00:57 1992
***************
*** 33,39 ****
    static string *dirs = NULL;
    string pk_var, pk_name, name;
!   char suffix[MAX_INT_LENGTH + 3];
  
!   sprintf (suffix, "%dpk", dpi);
  
    pk_var = getenv ("PKFONTS") ? "PKFONTS"
--- 33,39 ----
    static string *dirs = NULL;
    string pk_var, pk_name, name;
!   char suffix[MAX_INT_LENGTH + sizeof ".pk"];
  
!   sprintf (suffix, ".%dpk", dpi);
  
    pk_var = getenv ("PKFONTS") ? "PKFONTS"
***************
*** 43,47 ****
      dirs = initialize_path_list (pk_var, DEFAULT_PK_PATH);
  
!   name = make_suffix (font_name, suffix);
    pk_name = find_path_filename (name, dirs);
  
--- 43,47 ----
      dirs = initialize_path_list (pk_var, DEFAULT_PK_PATH);
  
!   name = concat (font_name, suffix);
    pk_name = find_path_filename (name, dirs);
  
***************
*** 60,66 ****
    static string *dirs = NULL;
    string gf_var, gf_name, name;
!   char suffix[MAX_INT_LENGTH + 3];
  
!   sprintf (suffix, "%dgf", dpi);
  
    gf_var = getenv ("GFFONTS") ? "GFFONTS" : "TEXFONTS";
--- 60,66 ----
    static string *dirs = NULL;
    string gf_var, gf_name, name;
!   char suffix[MAX_INT_LENGTH + sizeof ".pk"];
  
!   sprintf (suffix, ".%dgf", dpi);
  
    gf_var = getenv ("GFFONTS") ? "GFFONTS" : "TEXFONTS";
***************
*** 69,73 ****
      dirs = initialize_path_list (gf_var, DEFAULT_GF_PATH);
  
!   name = make_suffix (font_name, suffix);
    gf_name = find_path_filename (name, dirs);
  
--- 69,73 ----
      dirs = initialize_path_list (gf_var, DEFAULT_GF_PATH);
  
!   name = concat (font_name, suffix);
    gf_name = find_path_filename (name, dirs);
  
***************
*** 90,94 ****
      dirs = initialize_path_list ("TEXFONTS", DEFAULT_TFM_PATH);
  
!   name = make_suffix (font_name, "tfm");
    tfm_name = find_path_filename (name, dirs);
  
--- 90,94 ----
      dirs = initialize_path_list ("TEXFONTS", DEFAULT_TFM_PATH);
  
!   name = concat (font_name, ".tfm");
    tfm_name = find_path_filename (name, dirs);
  
diff -Nrc2 fontutils-0.5/lib/getopt.c fontutils-0.6/lib/getopt.c
*** fontutils-0.5/lib/getopt.c	Wed Aug 26 18:35:59 1992
--- fontutils-0.6/lib/getopt.c	Wed Oct 21 11:43:35 1992
***************
*** 37,44 ****
  #include <stdio.h>
  
- #if defined(USG) || defined(STDC_HEADERS) || defined(__GNU_LIBRARY__)
- #include <string.h>
- #endif
- 
  /* This needs to come after some library #include
     to get __GNU_LIBRARY__ defined.  */
--- 37,40 ----
***************
*** 148,151 ****
--- 144,151 ----
  
  #ifdef	__GNU_LIBRARY__
+ /* We want to avoid inclusion of string.h with non-GNU libraries
+    because there are many ways it can cause trouble.
+    On some systems, it contains special magic macros that don't work
+    in GCC.  */
  #include <string.h>
  #define	my_index	strchr
diff -Nrc2 fontutils-0.5/lib/make-suffix.c fontutils-0.6/lib/make-suffix.c
*** fontutils-0.5/lib/make-suffix.c	Fri Apr 10 16:51:11 1992
--- fontutils-0.6/lib/make-suffix.c	Thu Oct 22 17:58:11 1992
***************
*** 1,3 ****
! /* make-suffix.c: construct a suffix.
  
  Copyright (C) 1992 Free Software Foundation, Inc.
--- 1,3 ----
! /* make-suffix.c: unconditionally change the suffix on a string.
  
  Copyright (C) 1992 Free Software Foundation, Inc.
diff -Nrc2 fontutils-0.5/lib/malloc.c fontutils-0.6/lib/malloc.c
*** fontutils-0.5/lib/malloc.c	Fri May 15 09:03:26 1992
--- fontutils-0.6/lib/malloc.c	Tue Sep 22 16:29:09 1992
***************
*** 749,753 ****
  
  /*  who to call when sbrk returns failure */
! 
  #ifndef NO_NEW_HANDLER
  typedef volatile void (*vfp)();
--- 749,753 ----
  
  /*  who to call when sbrk returns failure */
! #define NO_NEW_HANDLER /* We need nothing fancy --karl */
  #ifndef NO_NEW_HANDLER
  typedef volatile void (*vfp)();
***************
*** 1097,1100 ****
--- 1097,1105 ----
        set_inuse(p);    /* don't let malloc consolidate us yet! */
        newmem = malloc(nb);
+       if (newmem == NULL)
+         {
+           fprintf (stderr, "realloc: malloc of %u bytes failed.\n", nb);
+           abort ();
+         }
        bcopy(mem, newmem, oldsize - SIZE_SZ);
        free(mem);
diff -Nrc2 fontutils-0.5/lib/report.c fontutils-0.6/lib/report.c
*** fontutils-0.5/lib/report.c	Fri Mar 27 14:50:44 1992
--- fontutils-0.6/lib/report.c	Mon Oct  5 10:12:33 1992
***************
*** 22,23 ****
--- 22,27 ----
  /* Says whether to output short progress reports as we run.  (-verbose)  */ 
  boolean verbose = false;
+ 
+ /* Where to output the reports.  If a particular program uses standard
+    output for real output, this gets changed to `stderr'.  */
+ FILE *report_file = stdout;
diff -Nrc2 fontutils-0.5/limn/.gdbinit fontutils-0.6/limn/.gdbinit
*** fontutils-0.5/limn/.gdbinit	Tue Jul 28 09:50:19 1992
--- fontutils-0.6/limn/.gdbinit	Mon Oct  5 12:26:16 1992
***************
*** 36,40 ****
  #-subdivide-threshold=.1 \
  #-range=\'-\' \
! #-do-display -display-stop \
  #
  #set args -verbose -log chab30 \
--- 36,40 ----
  #-subdivide-threshold=.1 \
  #-range=\'-\' \
! #-do-display  \
  #
  #set args -verbose -log chab30 \
***************
*** 43,65 ****
  #-filter-surround=4 \
  #-range=%-%
! #-do-display -display-stop \
  
! # set args -verbose -do-display -display-stop trap -dpi=72270
  
- #oen36 +corner-surround=15 +tangent-surround=15 \
- # error-threshold=3.0 +filter-iterations=4 +corner-always-threshold=50
  
- # helvR24 +range A-Z +corner-surround=1 +dpi=120 
- 
  # +dpi 1200 +line-threshold 16.0
  # +corner-surround 16 +error-threshold 35.0 +reparameterize-threshold 60.0 \
  
- #set args -verbose -log -dpi=1200 tmi72 \
- 
- #set args -verbose -log cmr10.300 \
- #  -do-display -display-stop\
- #  -range=.-.
- #  -range=\(-,
- 
  # The subdivide parameters make the stem of the t flow more nicely into
  # the tip.
--- 43,54 ----
  #-filter-surround=4 \
  #-range=%-%
! #-do-display  \
  
! # set args -verbose -do-display  trap -dpi=72270
  
  
  # +dpi 1200 +line-threshold 16.0
  # +corner-surround 16 +error-threshold 35.0 +reparameterize-threshold 60.0 \
  
  # The subdivide parameters make the stem of the t flow more nicely into
  # the tip.
***************
*** 80,89 ****
  #  -output-file ggmr26D
  ## -range=a-z \
! ##  -do-display -display-stop \
  ##  -log \
  
- #set args -verbose ligtest
- #set args -verbose cdr10
- 
  # Get Y from ring for sizing.
  #set args -verbose -output-file ../ourfonts/garamond/r/ring/Y-R \
--- 69,75 ----
  #  -output-file ggmr26D
  ## -range=a-z \
! ##  -do-display  \
  ##  -log \
  
  # Get Y from ring for sizing.
  #set args -verbose -output-file ../ourfonts/garamond/r/ring/Y-R \
***************
*** 99,101 ****
    ../ourfonts/garamond/r/ring/ring-r
  
! set args -verbose kgtA.746
--- 85,87 ----
    ../ourfonts/garamond/r/ring/ring-r
  
! set args -verbose -log ggsbi10.1200 -range=37-37
diff -Nrc2 fontutils-0.5/limn/ChangeLog fontutils-0.6/limn/ChangeLog
*** fontutils-0.5/limn/ChangeLog	Thu Sep  3 09:31:10 1992
--- fontutils-0.6/limn/ChangeLog	Tue Oct 27 13:02:50 1992
***************
*** 1,2 ****
--- 1,23 ----
+ Tue Oct 27 13:02:14 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* Version 0.6.
+ 
+ Sun Oct 25 14:22:34 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* output-bzr.c (bzr_output_char): No longer have BZR_CHAR_... macros.
+ 
+ Mon Oct  5 11:58:20 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* curve.c (print_curve): New param `print_t' to say whether to
+ 	print t values.
+         * curve.h: Change decl.
+         * fit.c: Change calls.
+ 
+ 	* xserver.c: Doc fix.
+ 
+ Sun Sep  6 16:46:27 1992  Karl Berry  (karl@hayley)
+ 
+         * display.c (x_output_char): call getchar, not scanf.
+ 
  Thu Sep  3 09:31:10 1992  Karl Berry  (karl@hayley)
  
diff -Nrc2 fontutils-0.5/limn/curve.c fontutils-0.6/limn/curve.c
*** fontutils-0.5/limn/curve.c	Sun Mar 29 19:10:32 1992
--- fontutils-0.6/limn/curve.c	Mon Oct  5 12:25:32 1992
***************
*** 100,105 ****
    /* The t value does not need to be set.  */
  }
- 
- 
  
  /* Show the pixels of the curve online.  */
--- 100,103 ----
***************
*** 124,129 ****
  #define NUM_TO_PRINT 3
  
  void
! log_curve (curve_type curve)
  {
    unsigned this_point;
--- 122,136 ----
  #define NUM_TO_PRINT 3
  
+ #define LOG_CURVE_POINT(c, p, print_t)					\
+   do									\
+     {									\
+       LOG2 ("(%.3f,%.3f)", CURVE_POINT (c, p).x, CURVE_POINT (c, p).y);	\
+       if (print_t)							\
+         LOG1 ("/%.2f", CURVE_T (c, p));					\
+     }									\
+   while (0)
+ 
  void
! log_curve (curve_type curve, boolean print_t)
  {
    unsigned this_point;
***************
*** 145,150 ****
    LOG ("  ");
    
!   /* If the whole curve is short enough, don't print it with ellipses,
!      etc.  */
    if (CURVE_LENGTH (curve) <= NUM_TO_PRINT * 2)
      {
--- 152,156 ----
    LOG ("  ");
    
!   /* If the curve is short enough, don't use ellipses.  */
    if (CURVE_LENGTH (curve) <= NUM_TO_PRINT * 2)
      {
***************
*** 151,157 ****
        for (this_point = 0; this_point < CURVE_LENGTH (curve); this_point++)
          {
!           LOG3 ("(%.3f,%.3f)/%.3f, ", CURVE_POINT (curve, this_point).x,
!                 CURVE_POINT (curve, this_point).y,
!                 CURVE_T (curve, this_point));
            if (this_point != CURVE_LENGTH (curve) - 1
                && (this_point + 1) % NUM_TO_PRINT == 0)
--- 157,163 ----
        for (this_point = 0; this_point < CURVE_LENGTH (curve); this_point++)
          {
!           LOG_CURVE_POINT (curve, this_point, print_t);
!           LOG (" ");
! 
            if (this_point != CURVE_LENGTH (curve) - 1
                && (this_point + 1) % NUM_TO_PRINT == 0)
***************
*** 164,169 ****
             this_point < NUM_TO_PRINT && this_point < CURVE_LENGTH (curve);
             this_point++)
!         LOG3 ("(%.3f,%.3f)/%.3f, ", CURVE_POINT (curve, this_point).x,
!               CURVE_POINT (curve, this_point).y, CURVE_T (curve, this_point));
  
        LOG ("...\n   ...");
--- 170,177 ----
             this_point < NUM_TO_PRINT && this_point < CURVE_LENGTH (curve);
             this_point++)
!         {
!           LOG_CURVE_POINT (curve, this_point, print_t);
!           LOG (" ");
!         }
  
        LOG ("...\n   ...");
***************
*** 172,177 ****
             this_point < CURVE_LENGTH (curve);
             this_point++)
!         LOG3 (", (%.3f,%.3f)/%.2f", CURVE_POINT (curve, this_point).x,
!               CURVE_POINT (curve, this_point).y, CURVE_T (curve, this_point));
      }
  
--- 180,187 ----
             this_point < CURVE_LENGTH (curve);
             this_point++)
!         {
!           LOG (" ");
!           LOG_CURVE_POINT (curve, this_point, print_t);
!         }
      }
  
***************
*** 202,213 ****
  
    LOG (" ");
    for (this_point = 0; this_point < CURVE_LENGTH (curve); this_point++)
!     LOG3 (" (%.3f,%.3f)/%.2f", CURVE_POINT (curve, this_point).x,
! 	  CURVE_POINT (curve, this_point).y, CURVE_T (curve, this_point));
  
    LOG (".\n");
  }
- 
- 
  
  /* Return an initialized but empty curve list.  */
--- 212,224 ----
  
    LOG (" ");
+ 
    for (this_point = 0; this_point < CURVE_LENGTH (curve); this_point++)
!     {
!       LOG (" ");
!       LOG_CURVE_POINT (curve, this_point, true);
!     }
  
    LOG (".\n");
  }
  
  /* Return an initialized but empty curve list.  */
***************
*** 250,255 ****
    curve_list->data[curve_list->length - 1] = curve;
  }
- 
- 
  
  /* Return an initialized but empty curve list array.  */
--- 261,264 ----
diff -Nrc2 fontutils-0.5/limn/curve.h fontutils-0.6/limn/curve.h
*** fontutils-0.5/limn/curve.h	Tue Jul 21 16:09:42 1992
--- fontutils-0.6/limn/curve.h	Mon Oct  5 12:22:03 1992
***************
*** 106,110 ****
  /* Write some or all, respectively, of the curve C in human-readable
     form to the log file, if logging is enabled.  */
! extern void log_curve (curve_type c);
  extern void log_entire_curve (curve_type c);
  
--- 106,110 ----
  /* Write some or all, respectively, of the curve C in human-readable
     form to the log file, if logging is enabled.  */
! extern void log_curve (curve_type c, boolean print_t);
  extern void log_entire_curve (curve_type c);
  
diff -Nrc2 fontutils-0.5/limn/display.c fontutils-0.6/limn/display.c
*** fontutils-0.5/limn/display.c	Mon Jul 27 15:54:04 1992
--- fontutils-0.6/limn/display.c	Sun Sep  6 16:53:02 1992
***************
*** 481,486 ****
    if (!display_continue)
      {
-       char dummy;
-       
        send_event (server_window, foserver_update_pixmap_atom, pixmap);
        XSync (display, False);
--- 481,484 ----
***************
*** 488,492 ****
        if (verbose) putchar ('\n');
        printf ("RET to continue: " );
!       scanf ("%c", &dummy);
      }
  }
--- 486,490 ----
        if (verbose) putchar ('\n');
        printf ("RET to continue: " );
!       (void) getchar ();
      }
  }
diff -Nrc2 fontutils-0.5/limn/fit.c fontutils-0.6/limn/fit.c
*** fontutils-0.5/limn/fit.c	Mon Jul 27 15:54:04 1992
--- fontutils-0.6/limn/fit.c	Mon Oct  5 12:22:03 1992
***************
*** 235,239 ****
    /* We filter all the curves in CURVE_LIST at once; otherwise, we would
       look at an unfiltered curve when computing tangents.  */
!   LOG ("\nFiltering curves (t values may be garbage):\n");
    for (this_curve = 0; this_curve < curve_list.length; this_curve++)
      {
--- 235,239 ----
    /* We filter all the curves in CURVE_LIST at once; otherwise, we would
       look at an unfiltered curve when computing tangents.  */
!   LOG ("\nFiltering curves:\n");
    for (this_curve = 0; this_curve < curve_list.length; this_curve++)
      {
***************
*** 930,934 ****
      }
  
!   log_curve (curve);
    display_curve (curve);
  }
--- 930,934 ----
      }
  
!   log_curve (curve, false);
    display_curve (curve);
  }
***************
*** 1383,1387 ****
      }
    LOG ("  reparameterized curve:\n   ");
!   log_curve (curve);
  
    return true;
--- 1383,1387 ----
      }
    LOG ("  reparameterized curve:\n   ");
!   log_curve (curve, true);
  
    return true;
diff -Nrc2 fontutils-0.5/limn/output-bzr.c fontutils-0.6/limn/output-bzr.c
*** fontutils-0.5/limn/output-bzr.c	Wed Apr 15 15:42:34 1992
--- fontutils-0.6/limn/output-bzr.c	Sun Oct 25 14:22:46 1992
***************
*** 70,77 ****
    CHAR_SET_WIDTH (bzr_char) = PIXELS_TO_POINTS (CHAR_SET_WIDTH (c), dpi_real);
  
!   BZR_CHAR_MIN_COL (bzr_char) = PIXELS_TO_POINTS (CHAR_MIN_COL (c), dpi_real);
!   BZR_CHAR_MAX_COL (bzr_char) = PIXELS_TO_POINTS (CHAR_MAX_COL (c), dpi_real);
!   BZR_CHAR_MIN_ROW (bzr_char) = PIXELS_TO_POINTS (CHAR_MIN_ROW (c), dpi_real);
!   BZR_CHAR_MAX_ROW (bzr_char) = PIXELS_TO_POINTS (CHAR_MAX_ROW (c), dpi_real);
  
    /* We have to change all the values in the spline list to be in
--- 70,77 ----
    CHAR_SET_WIDTH (bzr_char) = PIXELS_TO_POINTS (CHAR_SET_WIDTH (c), dpi_real);
  
!   CHAR_MIN_COL (bzr_char) = PIXELS_TO_POINTS (CHAR_MIN_COL (c), dpi_real);
!   CHAR_MAX_COL (bzr_char) = PIXELS_TO_POINTS (CHAR_MAX_COL (c), dpi_real);
!   CHAR_MIN_ROW (bzr_char) = PIXELS_TO_POINTS (CHAR_MIN_ROW (c), dpi_real);
!   CHAR_MAX_ROW (bzr_char) = PIXELS_TO_POINTS (CHAR_MAX_ROW (c), dpi_real);
  
    /* We have to change all the values in the spline list to be in
diff -Nrc2 fontutils-0.5/limn/version.c fontutils-0.6/limn/version.c
*** fontutils-0.5/limn/version.c	Thu Sep  3 09:46:21 1992
--- fontutils-0.6/limn/version.c	Tue Oct 27 13:28:00 1992
***************
*** 1 ****
! char *version_string = "limn version 0.5";
--- 1 ----
! char *version_string = "limn version 0.6";
